<template>
  <div>
    <v-card>
      <v-tabs v-model="tab" background-color="transparent" grow>
        <v-tab v-for="item in products" v-bind:key="item.id">{{ item.category }}</v-tab>
        <v-tabs-items v-model="tab">
          <v-tab-item v-for="item in products" :key="item.id">
            <v-row>
              <v-col cols="12" md="8">
                <v-text-field
                  v-model="search"
                  append-icon="mdi-magnify"
                  label="Buscar"
                  single-line
                  hide-details
                  class="mx-2"
                ></v-text-field>
              </v-col>
              <v-col cols="12" md="4" class="text-center">
                <v-btn v-if="loggedIn==true && lastPurchase>6" dark x-large color="#414142" @click="dialog = !dialog, calculateTotal()">Lista de compras</v-btn>
              </v-col>
              <v-col v-for="n in item.products" v-bind:key="n.id" cols="12" lg="3" md="4" sm="6">
                <v-card raised>
                  <v-img :src="n.photoUrl" height="200px"></v-img>
                  <v-card-text>
                    <h2>{{ n.info.product_name }}</h2>
                    Precio: {{ n.info.cost }} por {{n.info.quantity}} {{n.info.unit_measurement}}
                    <div>
                      ¿Cuanto desea? {{n.productInCart}} {{n.info.unit_measurement}}
                    </div>
                  </v-card-text>
                  <v-card-actions>
                    <v-btn v-if="loggedIn==true && lastPurchase>6" icon :disabled="toast"
                      :loading="toast">
                      <v-icon large @click="sendProduct(n), toast=true">mdi-check</v-icon>
                    </v-btn>
                    <v-spacer></v-spacer>
                    <v-btn v-if="loggedIn==true && lastPurchase>6" icon>
                      <v-icon large @click="decreaseQuantity(n.info.quantity, n.id)">mdi-minus-circle</v-icon>
                    </v-btn>
                    <v-btn v-if="loggedIn==true && lastPurchase>6" icon>
                      <v-icon large @click="increaseQuantity(n.info.quantity, n.id)">mdi-plus-circle</v-icon>
                    </v-btn>
                  </v-card-actions>
                </v-card>
              </v-col>
            </v-row>
          </v-tab-item>
        </v-tabs-items>
      </v-tabs>
      <v-dialog v-model="dialog" max-width="500px">
        <v-card>
          <v-card-title>
            <span class="headline">Lista de Compras</span>
          </v-card-title>
          <v-card-text>
            <v-simple-table dense>
              <template v-slot:default>
                <thead>
                  <tr>
                    <th class="text-left">Nombre</th>
                    <th class="text-left">Precio</th>
                    <th class="text-left">Cantidad</th>
                    <th class="text-left">Total</th>
                  </tr>
                </thead>
                <tbody>
                  <tr v-for="item in productsList" :key="item.id">
                    <td>{{ item.name }}</td>
                    <td>{{ item.price }}</td>
                    <td>{{item.amount}}{{ item.quantity }}</td>
                    <td>{{item.amount*item.price }}</td>
                    <td class="text-center">
                      <v-btn icon dark color="#414142" @click="deleteProducts(item.id), calculateTotal()">
                        <v-icon dark>mdi-delete</v-icon>
                      </v-btn>
                    </td>
                  </tr>
                  <tr>
                    <td>Precio Total:</td>
                    <td></td>
                    <td></td>
                    <td>{{priceList}}</td>
                    <td></td>
                  </tr>
                </tbody>
              </template>
            </v-simple-table>
          </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn dark color="red" @click="dialog = false">Cancelar</v-btn>
            <v-btn v-if="productsList.length!=0" dark color="#8CC63F" @click="dialog = false, makePurchase()">Realizar compra</v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-snackbar
        v-model="toast"
        :timeout="timeout"
      >
        {{ toast_msg }}
        <v-btn
          color="blue"
          text
          @click="toast = false"
        >
          Close
        </v-btn>
      </v-snackbar>
    </v-card>
  </div>
</template>

<script>
import "firebase/auth";
import * as firebase from "firebase/app";
export default {
  props: {
    loggedIn: {
      type: Boolean
    },
    lastPurchase: {
      
    }
  },
  name: "ListaProductos",
  data() {
    return {
      timeout: 1500,
      sale:[],
      toast: false,
      toast_msg: "",
      dialog: null,
      productsList: [],
      priceList: 0,
      search: null,
      tab: null,
      products: []
    };
  },
  methods: {
    sendProduct(a) {
      this.calculateTotal()
      let exist=false
      if(a.productInCart>0){
        if(this.priceList+(a.productInCart*a.info.cost)>700){
          this.toast_msg="No se puede tener más de $700 en productos"
        }else{
          this.productsList.forEach(produ => {
            if(produ.id==a.id){
              exist=true
              produ.amount+=a.productInCart
            }
          });
          if(exist==false)
            this.productsList.push({id: a.id, name: a.info.product_name, price: a.info.cost, 
            quantity: a.info.unit_measurement, amount: a.productInCart});
          this.toast_msg="Se agregaron "+a.productInCart+a.info.unit_measurement+" de "+a.info.product_name
        }
        this.products.forEach(cate => {
          cate.products.forEach(produ => {
            if(produ.id==a.id){
              produ.productInCart=0
            }
        })
        })
      }else{
        this.toast_msg="No se ha seleccionado la cantidad del producto"
      }
    },
    deleteProducts(id){
      this.productsList.forEach(product => {
            if(product.id==id){
              this.productsList.splice(this.productsList.indexOf(product), 1)
            }
        })
    },
    consultaProductos() {
      this.$axios
        .get(`http://${process.env.VUE_APP_API_URL}/api/products`)
        .then(res => {
          res.data.data.forEach(product => {
            this.products.push(product);
          });
        });
    },
    increaseQuantity(a, b){
      this.products.forEach(cate => {
        cate.products.forEach(produ => {
          if(produ.id==b){
            produ.productInCart+=a
          }
      });
      });
    },
    decreaseQuantity(a, b){
      this.products.forEach(cate => {
        cate.products.forEach(produ => {
          if(produ.id==b){
            if(produ.productInCart>0)
              produ.productInCart-=a
          }
      });
      });
    },
    calculateTotal(){
      let total=0
      this.productsList.forEach(product => {
        total+=product.amount*product.price
      })
      this.priceList=total
    },
    async makePurchase(){
      const token = await firebase.auth().currentUser.getIdToken();
      let config = {
            headers:{
              authorization: `Bearer ${token}`
            },
            body:{
              
            }
          }
      this.sale.push({cost:this.priceList, products:this.productsList, packages:[]})
      this.$axios
        .post(`http://${process.env.VUE_APP_API_URL}/api/sales`,{sales:this.sale}, config)
        .then(res =>{
          if(res.data.message=="successful sale"){
            this.productsList=[]
            this.toast_msg="Pedido realizado correctamente"
            this.toast=true
            this.$emit('toOrder', 2)
          }
        })
        .catch(function(err){
          console.log(err)
        })
    },
  },

  created() {
    this.consultaProductos();
  }
};
</script>

